package flex.testdrive.store;

import java.util.List;
import java.util.Collection;

import flex.data.DataSyncException;
import flex.data.assemblers.AbstractAssembler;

public class ProductAssembler extends AbstractAssembler {

	public Collection fill(List fillParameters) {
		ProductService service = new ProductService();
		return service.getProducts();
	}

	public void createItem(Object newItem) {
	}

	public void updateItem(Object newVersion, Object prevVersion, List changes) {
		ProductService service = new ProductService();
		try {
			service.update((Product) newVersion);
		} catch (ConcurrencyException e) {
			int productId = ((Product) newVersion).getProductId();
			System.err.println("*** Throwing DataSyncException when trying to update product id=" + productId);
			// The the conflict error which contains the current version of the
			// company so the client can reconile.
			throw new DataSyncException(service.getProduct(productId), changes);
		}
	}

	public void deleteItem(Object prevVersion) {
	}

}