package flex.testdrive.store;

import java.util.ArrayList;
import java.util.List;
import java.sql.*;

import flex.testdrive.ConnectionHelper;
import flex.testdrive.DAOException;

public class ProductService {

	public List getProducts() {

		ArrayList list = new ArrayList();

		Connection c = null;

		try {
			c = ConnectionHelper.getConnection();
			Statement s = c.createStatement();
			ResultSet rs = s.executeQuery("SELECT * FROM product ORDER BY name");
			while (rs.next()) {
				list.add(new Product(
						rs.getInt("product_id"), 
						rs.getString("name"), 
						rs.getString("description"), 
						rs.getString("image"), 
						rs.getString("category"), 
						rs.getDouble("price")));
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			try {
				c.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return list;

	}

	public Product getProduct(int productId) throws DAOException {
		return null;
	}

	public void update(Product product) throws DAOException,
			ConcurrencyException {

		Connection c = null;

		try {
			c = ConnectionHelper.getConnection();
			PreparedStatement ps = c.prepareStatement("UPDATE product SET name=?, description=?, image=?, category=?, price=? WHERE product_id=?");
			ps.setString(1, product.getName());
			ps.setString(2, product.getDescription());
			ps.setString(3, product.getImage());
			ps.setString(4, product.getCategory());
			ps.setDouble(5, product.getPrice());
			ps.setInt(6, product.getProductId());
			if (ps.executeUpdate() == 0) {
				throw new ConcurrencyException("Item not found");
			}
		} catch (Exception e) {
			e.printStackTrace();
			throw new DAOException(e);
		} finally {
			try {
				c.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}

	}

}